



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>（一）七种AOP实现方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">（一）七种AOP实现方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:45:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在这里列表了我想到的在你的应用程序中加入AOP支持的所有方法。这里最主要的焦点是拦截，因为一旦有了拦截其它的事情都是细节。</p>
<table>
<tbody>
<tr>
<td>
<p>Approach</p>
<p>方法</p>
</td>
<td>
<p>Advantages</p>
<p>优点</p>
</td>
<td>
<p>Disadvantages</p>
<p>缺点</p>
</td>
</tr>
<tr>
<td>
<p>Remoting Proxies</p>
<p>远程代理</p>
</td>
<td>
<p>Easy to implement, because of the .Net framework support</p>
<p>容易实现，因为有.NET框架的支持。</p>
</td>
<td>
<p>Somewhat heavyweight<br />Can only be used on interfaces or MarshalByRefObjects</p>
<p>微显重量级</p>
<p>仅在接口或MarshalByRefObjects 上使用</p>
</td>
</tr>
<tr>
<td>
<p>Derivingfrom ContextBoundObject</p>
<p>从ContextBoundObject 派生</p>
</td>
<td>
<p>Easiest to implement<br />Native support for call interception</p>
<p>很容易实现</p>
<p>原生支持调用拦截</p>
</td>
<td>
<p>Very costly in terms of performance</p>
<p>非常昂贵的性能代价</p>
</td>
</tr>
<tr>
<td>
<p>Compile-time subclassing<br />( Rhino Proxy )</p>
<p>编译时子类化</p>
</td>
<td>
<p>Easiest to understand</p>
<p>很容易理解</p>
</td>
<td>
<p>Interfaces or virtual methods only</p>
<p>仅用于接口或虚方法</p>
</td>
</tr>
<tr>
<td>
<p>Runtime subclassing<br />( Castle Dynamic Proxy )</p>
<p>运行时子类化</p>
</td>
<td>
<p>Easiest to understand<br />Very flexible</p>
<p>很容易理解</p>
<p>非常灵活</p>
</td>
<td>
<p>Complex implementation (but alreadyexists)<br />Interfaces or virtual methods only</p>
<p>复杂的实现（已经实现）</p>
<p>仅用于接口或虚方法</p>
</td>
</tr>
<tr>
<td>
<p>Hooking into the profiler API<br />( Type Mock )</p>
<p>分析 API钩子</p>
</td>
<td>
<p>Extremely powerful</p>
<p>极端强大</p>
</td>
<td>
<p>Performance?<br />Complex implementation (COM API, require separate runner, etc)</p>
<p>性能未知</p>
<p>复杂实现（COM API，需要单独运行等）</p>
</td>
</tr>
<tr>
<td>
<p>Compile time IL-weaving&nbsp;<br />( Post Sharp / Cecil )</p>
<p>编译时 IL织入</p>
</td>
<td>
<p>Very powerful<br />Good performance</p>
<p>非常强大</p>
<p>良好的性能</p>
</td>
<td>
<p>Very hard to implement</p>
<p>实现非常困难</p>
</td>
</tr>
<tr>
<td>
<p>Runtime IL-weaving<br />( Post Sharp / Cecil )</p>
<p>运行时 IL织入</p>
</td>
<td>
<p>Very powerful<br />Good performance</p>
<p>非常强大</p>
<p>朗好的性能</p>
</td>
<td>
<p><em>Very&nbsp;</em>hard to implement</p>
<p>实现非常困难</p>
</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn2yxgq.html">IIS 7&period;5 &plus; PHP-5&period;6&period;3 &plus; mysql-5&period;6&period;21&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5w3kq.html">javascript进阶系列专题：作用域与作用域链</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r76pd8.html">动态组合lambda 表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3nzp8.html">UINavigationController push时，页面卡顿</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3pxjq.html">如何实现 Android 应用的持续部署？</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p44xz9.html">css定位的简单总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4rwxj8.html">WCF安装Windows服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdexjdz9.html">Model</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1kyp38.html">sql server 2008数据复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1e24k8.html">SRM 386&lpar;1-250pt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k17jdj9.html">找到 OSChina 早上 8 点钟容易宕机的原因 ？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03ykgq.html">什么是空间复杂度（What is actually Space Complexity &quest;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96plr548.html">Java中的类型转换&lpar;Integer、Long、String&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk3zvz8.html">从后台servlet中，获取jsp页面输入的值，来删除用户一行信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozw6j8.html">tmux复制模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gn3lmq.html">spring的第二天</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj65739.html">&lbrack;BZOJ2238&rsqb;Mst</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd74o09.html">Spring Boot安装及入门实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kvzlxq.html">eclipse Reference 功能之&mdash;&mdash;项目之间的引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7evmwe9.html">c&plus;&plus;之&mdash;&mdash; lambda表达式（有个未能解决的问题等待大佬解答）&mdash;&mdash;（在stack overflow找到了答案）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1nv609.html">HDU 6375&lpar;双端队列 ~&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ndjg9.html">Spark源码剖析 - SparkContext的初始化&lpar;二&rpar;&lowbar;创建执行环境SparkEnv</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wdk1gq.html">tcp&lowbar;connect函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjnrm9.html">三十、Linux 进程与信号&mdash;&mdash;信号的概念及 signal 函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy4nwjq.html">关于AJAX的基础操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2zpzy9.html">VS中ipch文件夹和sdf文件的处理方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2zw7x9.html">使用TensorFlow遇到的若干问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwd4ox9.html">利用PyMySQL库连接数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwkovy8.html">MySql数据库学习笔记&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25mzw3q.html">scss转css的过程中  转化问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
